/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Benjamin Grauer
   co-programmer: ...
*/

#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LOADING

#include "resource.h"
#include "filesys/file.h"

ObjectListDefinition(Resource);


std::vector<Resource::Type*>    Resource::_resourceTypes;

//! GLOBALS
Directory Resource::_mainGlobalPath;
std::vector<Directory>        Resource::_globalPaths;


/**
 * standard constructor
*/
Resource::Resource (Resource::Type* type)
    : _pointer(NULL), _type(type)
{
  this->registerObject(this, Resource::_objectList);

  if(this->_type->id() == -1)
  {
    Resource::_resourceTypes.push_back(this->_type);
    this->_type->setID(Resource::_resourceTypes.size()-1);
  }

}

/**
 * standard deconstructor
 */
Resource::~Resource ()
{
  // delete what has to be deleted here
}


std::string Resource::locateFile(const std::string& fileName)
{
  if (File(fileName).exists())
    return fileName;
  else if ((Resource::_mainGlobalPath+File(fileName)) . exists() )
    return (Resource::_mainGlobalPath + File(fileName)).name();


  return std::string("/home/bensch/svn/orxonox/data/") + fileName;

}


Resource::Pointer* Resource::acquireResource(const std::string& loadString)
{
  //const Resource::Type* const type = Resource::_resourceTypes[this->_type->id()];

  for (unsigned int i = 0; i < _type->storedResources().size(); ++i)
    if (_type->storedResources()[i]->_pointer->loadString() == loadString)
      return _type->storedResources()[i]->_pointer;

  return NULL;
}

void Resource::setMainGlobalPath(const Directory& directory)
{
  Resource::_mainGlobalPath = directory;
  Resource::_mainGlobalPath.open();
}

void Resource::addGlobalPath(const Directory& directory)
{
  std::vector<Directory>::const_iterator it = std::find(Resource::_globalPaths.begin(), Resource::_globalPaths.end(), directory);
  if (it == Resource::_globalPaths.end())
    Resource::_globalPaths.push_back(directory);
}



void Resource::addResource(Resource::Pointer* pointer)
{}










void Resource::KeepLevel::setKeepLevelName(unsigned int level, const std::string& name)
{
  if (_keepLevelName.size() <= level)
    _keepLevelName.resize(level+1);
  _keepLevelName[level] = name;
}










Resource::Pointer::Pointer(const std::string& loadString, const Resource::KeepLevel& keeplevel)
{
}

void Resource::Type::setID(int id)
{
  this->_id = id;
}
